#include <octave/oct.h>

#include <pt-all.h>
#include <pt-emit-cplusplus.h>
#include <parse.h>

using namespace std;

DEFUN_DLD(compile, args, , "compile")
{
  if(args.length() > 0 
     && args(0).is_string())
    {
      symbol_record *s = lookup_by_name(args(0).string_value(),false);
      
      if (s && s->is_function())
	{
	  tree_emit_cplusplus tpc(cout);
	  tpc.set_debug_mode ();

	  octave_user_function *f = (octave_user_function*)s->def().function_value();
	  
	  tree_statement_list *bd = f->body();
	  

	  cout << "#include <octave/oct.h>\n\n";
	  cout 
	    << "extern void\n"
	    << f->function_name()<<" (";

	  tree_parameter_list *pl = f->parameter_list ();
	  tree_parameter_list *rl = f->return_list ();
	  
	  // Find matching parameter variables
	  int pl_len = 0;
	  int rl_len = 0;

	  if(pl)
	      pl_len = pl->length();

	  if (rl)
	    rl_len = rl->length();

	  bool pl_match[pl_len];
	  bool rl_match[rl_len];
	  int pl_index = 0;

	  if (pl)
	    {
	      for (unsigned int i = 0; i< pl->length(); i++)
	      pl_match[i] = false;
	    }
	  if (rl)
	    {
	      for (unsigned int i = 0; i< rl->length(); i++)
		rl_match[i] = false;
	    }

	  if (pl && rl)
	    {
	      tree_parameter_list::iterator plp = pl->begin();
	      //Pix plp = pl->first ();

	      while (plp != pl->end())
		{
		  // Check this parameter name
		  tree_identifier *pid = *plp;

		  plp++;

		  if (pid)
		    {
		      // with these return list names
		      tree_parameter_list::iterator rlp = rl->begin();
		      int rl_index = 0;

		      while (rlp != rl->end())
			{
			  tree_identifier *rid = *rlp;
			  
			  rlp++;

			  if (rid)
			    {
			      pl_match[pl_index] |= (pid->name() == rid->name());
			      rl_match[rl_index] |= (pid->name() == rid->name());
			    }
			  rl_index++;
			}
		    }
		  pl_index++;
		}
	    }

	  if(pl)
	    {
	      tree_parameter_list::iterator p = pl->begin ();
	      pl_index = 0;

	      if(p != pl->end ())
		{
		  tree_identifier *elt = *p;
	  
		  while (p != pl->end ())
		    {
		      p++;

		      if(elt)
			{
			  if(pl_match[pl_index])
			    cout << "octave_value& ";
			  else
			    cout << "const octave_value& ";

			  cout << elt->name();
			  tpc.symbol_used (elt->name(), true);
			}

		      if(p == pl->end ())
			break;
		      elt = *p;
	      
		      if (elt)
			cout<< ", ";
		      
		      pl_index++;
		    }
		}
	    }
	  
	  if(rl)
	    {
	      if (pl)
		{
		  cout<<",\n";
		  for (unsigned int i= 0;i< f->function_name().length();i++)
		    cout<<" ";

		  cout<<"  ";
		}

	      tree_parameter_list::iterator p = rl->begin ();
	      int rl_index = 0;

	      if(p != rl->end ())
		{
		  tree_identifier *elt = *p;
	  
		  while (p != rl->end ())
		    {
		      p++;

		      if(elt)
			{
			  if(!rl_match[rl_index])
			    {
			      cout << "octave_value& ";

			      cout << elt->name();
			      tpc.symbol_used (elt->name(), true);
			    }
			}

		      if(p == rl->end ())
			break;
		      elt = *p;
	      
		      if (elt && rl_match[rl_index])
			cout<< ", ";
		      
		      rl_index++;
		    }
		}
	    }
	  
	  cout<<")\n{\n";

	  bd->accept(tpc);

	  cout<<"}"<<endl;
	}
    }

  return octave_value();
}
